#!/usr/bin/env python
# -*- encoding=utf-8 -*-
# Descript: 为系统安装Nginx + PHP + MySQL 环境
# Tips: 仅适应于Redhat 6系统

from fabric.colors import *
from fabric.api import *

# 定义业务机器
env.user = 'root'
env.port = '22'
env.roledefs = {
	'wbroles' : ['192.168.198.201', '192.168.198.202'],
	'dbroles' : ['192.168.198.205']
}
env.passwords = {
	'root@192.168.198.201:22' : 'vqiu..',
	'root@192.168.198.202:22' : 'vqiu..',
	'root@192.168.198.205:22' : 'vqiu..'
}
	
@roles('wbroles')
def web_task():
	print yellow('正在安装Nginx、PHP-FPM,请稍候...',bold=True)
	with settings(warn_only=True):
		run('yum -y install epel-release')
		run('rpm -Uvh http://rpms.famillecollet.com/enterprise/remi-release-6.rpm')
		run('rpm -Uvh http://nginx.org/packages/centos/6/noarch/RPMS/nginx-release-centos-6-0.el6.ngx.noarch.rpm')
		run('yum -y --enablerepo=remi,remi-php55 install php-fpm php-common php-devel php-mysqlnd php-mbstring php-mcrypt php-gd php-xml')
		run('yum -y --enablerepo=nginx install nginx')
		run('chkconfig nginx on')
		run('chkconfig php-fpm on')

@roles('dbroles')
def db_task():
	print yellow('正在安装MySQL，请稍候...',bold=True)
	with settings(warn_olny=True):
		run('yum -y install epel-release')
		run('rpm -Uvh rpm -Uvh http://rpms.famillecollet.com/enterprise/remi-release-6.rpm')
		run('yum -y install --enablerepo=remi mysql mysql-devel mysql-server')
		run('chkconfig mysqld on')
		run('service mysqld start')


@roles('wbroles', 'dbroles')
def public_task():
	print yellow('服务器正在优化中，请稍候',bold=True)
	with settings(warn_olny=True):
		run('rpm -qa|grep ntpdate>/dev/null 2>&1;if [[ $? -eq 1 ]];then yum -y install ntpdate; fi')
		run('ntpdate -sb cn.pool.ntp.org')


def deploy():
	execute(public_task)
	execute(web_task)
	execute(db_task)
